unit Arrays;

interface

uses Windows,Kol,Share,Messages,Debug;

type 
 THIArrays = class(TDebug)
  private
    _Arr,CBArray,VSArray,ENArray: PArray;
    PM:PMenu;
    ind: integer;

  protected
    function _Count:integer;
    procedure _Set(var Item: TData; var Val: TData);
    function _Get(Var Item: TData; var Val: TData): boolean;
    procedure _Add(var Val:TData);

    procedure SetCB(var Item:TData; var Val:TData);
    function GetCB(Var Item:TData; var Val:TData):boolean;
    procedure SetVS(var Item:TData; var Val:TData);
    function GetVS(Var Item:TData; var Val:TData):boolean;
    procedure SetEN(var Item:TData; var Val:TData);
    function GetEN(Var Item:TData; var Val:TData):boolean;
    
  public
    procedure _var_Array(var _Data:TData; Index:word);
    procedure _var_CBArray(var _Data:TData; Index:word);
    procedure _var_VSArray(var _Data:TData; Index:word);
    procedure _var_ENArray(var _Data:TData; Index:word);
    procedure _var_Count(var _Data:TData; Index:word);

  end;

implementation

//#########################      ############################

function THIArrays._Count:integer;
begin
   Result := PM.Count;
end;

procedure THIArrays._var_Count;
begin
   dtInteger(_Data, PM.Count);
end;

{procedure TArrays._var_Handle;
begin
   _Data.Data_type := data_int;
   _Data.idata := PM.ItemHandle[0];
end;}

//#####################################################################
//#                                                                   #
//#                                              #
//#                                                                   #
//#####################################################################

procedure THIArrays._Set(var Item:TData; var Val:TData);
begin
  ind := ToInteger(Item);
  if(ind >= 0) and (ind < PM.Count) then
     PM.ItemText[ind]:= ToString(Val);
end;

function THIArrays._Get(Var Item:TData; var Val:TData):boolean;
begin
  ind := ToInteger(Item);
  if(ind >= 0 )and(ind < PM.Count )then
   begin
    dtString(Val, PM.ItemText[ind]);
    Result := true;
   end
  else Result := false;
end;

procedure THIArrays._Add;
var sdt:string;
begin
  sdt := ToString(Val);
  if sdt = '-' then PM.AddItem('-',nil,[moSeparator])
  else PM.AddItem(PChar(sdt),nil,[]);
 // DrawXPStyle;
end;

procedure THIArrays._var_Array;
begin
   if _arr = nil then
     _Arr := CreateArray(_Set,_Get,_Count,_Add);
   _Data.Data_type := data_array;
   _Data.idata := integer(_Arr);
end;

//#####################################################################
//#                                                                   #
//#                                              #
//#                                                                   #
//#####################################################################

procedure THIArrays._var_CBArray;
begin
   if CBArray = nil then CBArray := CreateArray(SetCB,GetCB,_Count,nil);
   dtArray(_Data, CBArray);
end;

procedure THIArrays.SetCB(Var Item:TData; var Val:TData);
begin
  ind := ToInteger(Item);
  if(ind >= 0) and (ind < PM.Count) then
   begin
    Val.Data_type := data_int;
    if  Val.idata = 0 then PM.ItemChecked[ind]:= False
    else PM.RadioCheck(ind);
   end
end;

function THIArrays.GetCB(Var Item:TData; var Val:TData):boolean;
begin
  ind := ToInteger(Item);
  if(ind >= 0) and (ind < PM.Count) then
   begin
    Val.Data_type := data_int;
    if PM.ItemText[ind] = '' then Val.idata := -1
    else Val.idata := integer(PM.ItemChecked[ind]);
    Result := true;
   end
  else Result := false;
end;

//#####################################################################
//#                                                                   #
//#                                            #
//#                                                                   #
//#####################################################################

procedure THIArrays._var_VSArray;
begin
   if VSArray = nil then VSArray := CreateArray(SetVS,GetVS,_Count,nil);
   dtArray(_Data, VSArray);
end;

procedure THIArrays.SetVS(Var Item:TData; var Val:TData);
begin
  ind := ToInteger(Item);
  if(ind >= 0) and (ind < PM.Count) then
   begin
    Val.Data_type := data_int;
    if  Val.idata = 0 then PM.ItemVisible[ind]:=False
    else PM.ItemVisible[ind]:=True;
   end
end;

function THIArrays.GetVS(Var Item:TData; var Val:TData):boolean;
begin
  ind := ToInteger(Item);
  if(ind >= 0) and (ind < PM.Count) then
   begin
    Val.Data_type := data_int;
    Val.idata := integer(PM.ItemVisible[ind]);
    Result := true;
   end
  else Result := false;
end;

//#####################################################################
//#                                                                   #
//#                                           #
//#                                                                   #
//#####################################################################
  
procedure THIArrays._var_ENArray;
begin
   if ENArray = nil then ENArray := CreateArray(SetEN,GetEN,_Count,nil);
   dtArray(_Data, ENArray);
end;

procedure THIArrays.SetEN(Var Item:TData; var Val:TData);
begin
  ind := ToInteger(Item);
  if(ind >= 0) and (ind < PM.Count) then
   begin
    Val.Data_type := data_int;
    if  Val.idata = 0 then PM.ItemEnabled[ind]:=False
    else PM.ItemEnabled[ind]:=True;
   end
end;

function THIArrays.GetEN(Var Item:TData; var Val:TData):boolean;
begin
  ind := ToInteger(Item);
  if(ind >= 0) and (ind < PM.Count) then
   begin
    Val.Data_type := data_int;
    Val.idata := integer(PM.ItemEnabled[ind]);
    Result := true;
   end
  else Result := false;
end;

end.