unit hiPopupMenu;

interface

uses Windows,Kol,Share,Messages,Debug,Arrays;

type
  THIPopupMenu = class(TDebug)
   private
    PM:PMenu;
    FC:PControl;
    Old:TOnMessage;

    procedure SetMenu(const Value:string);
    procedure AddMenuItem(const Caption:string);
    function _OnMes( var Msg: TMsg; var Rslt: Integer ): Boolean;

    procedure Init;
   public
    _event_onClick:THI_Event;
    _event_onEndPopup:THI_Event;

    constructor Create(Control:PControl);
    destructor Destroy; override;
    procedure _work_doPopup(var _Data:TData; Index:word);
    procedure _work_doPopupHere(var _Data:TData; Index:word);
    procedure _work_doAddItem(var _Data:TData; Index:word);
    procedure _work_doClear(var _Data:TData; Index:word);
    procedure _var_Handle(var _Data:TData; Index:word);
    property _prop_Menu:string write SetMenu;
  end;

implementation

constructor THIPopupMenu.Create;
begin
   inherited Create;
   FC := Control;
   old := FC.OnMessage;
   FC.OnMessage := _OnMes;
   PM := NewMenu(nil,0,[],nil);
   InitAdd(init);
end;

procedure THIPopupMenu.Init;
begin
end;

destructor THIPopupMenu.Destroy;
begin
   FC.OnMessage := old;
   PM.Free;
   inherited;
end;

function THIPopupMenu._OnMes;
var m:PMenu;
begin
   case Msg.message of
    WM_COMMAND:
      begin
       m := PM.Items[Msg.WParam];
       if m <> nil then
        _hi_OnEvent(_event_onClick,PM.IndexOf(m));
      end;
   end;
   Result := Old(Msg,Rslt);
end;

procedure THIPopupMenu.AddMenuItem;
begin
   if Caption = '-' then
     PM.AddItem('-',nil,[moSeparator])
   else PM.AddItem(PChar(Caption),nil,[]);
end;

procedure THIPopupMenu.SetMenu;
var
  List:PStrList;
  i:integer;
begin
   List := NewStrList;
   List.text := Value;
   for i := 0 to List.Count-1 do
    AddmenuItem(List.Items[i]);
   List.Free;
end;

procedure THIPopupMenu._work_doPopup;
var pos:cardinal;
begin
   pos := Cardinal(ToInteger(_data));
   TrackPopupMenu(PM.Handle,0,pos and $ffff,pos shr 16,0,FC.Handle,nil);
   _hi_OnEvent(_event_onEndPopup);
end;

procedure THIPopupMenu._work_doAddItem;
begin
   AddMenuItem(ToString(_Data));
end;

procedure THIPopupMenu._work_doClear;
begin
   PM.Free;
   PM := NewMenu(nil,100,[],nil);
end;

procedure THIPopupMenu._work_doPopupHere;
var pos:TPoint;
begin
   GetCursorPos(pos);
   SetForegroundWindow( FC.Handle );
   with pos do
     TrackPopupMenu(PM.Handle,0,x,y,0,FC.Handle,nil);
   _hi_OnEvent(_event_onEndPopup);
end;

procedure THIPopupMenu._var_Handle;
begin
   dtInteger(_Data,PM.ItemHandle[0]);
end;

end.